% LRUstack es una pila donde se almacenan las distintas referencias segun
% vayan apareciendo y a su vez se van almacenando las distancias desde la
% ultima referencia cuando aparece una referencia repetida, de este modo
% conseguimos representar la localidad temporal.

function LRUstack(id)

maxpila=1000;  % Consideramos un tamao maximo de pila de 1000
pila=zeros(maxpila,1)-1;
stack=zeros(length(id),1);

for i=1:length(id) % Si encontramos la nueva referencia dentro de la pila debemos desplazar todas las referencias anteriores
    d=find(pila(:)==id(i));% hacia abajo y colocar la nueva referencia al principio de la pila
    if d>0                          
       pila(2:d)=pila(1:d-1);
       stack(i)=d;
    else                                                % Si no lo encontramos, desplazamos todas las referencias y colocamos la nueva al principipo
       pila(2:maxpila)=pila(1:maxpila-1);
    end
    pila(1)=id(i); 
   
end

stack=sortrows(stack,1);    % En stack almacenamos todas las distancias entre referencias
[val,rep]=mmrepeat(stack);  % Ahora contamos el numero de distancias =1 que se producen, =2, =3 =4, .....
val=val(2:length(val));     % Debemos quitar los ceros ya que esos han sido introducidos para definir el tamao de la pila y no indica ninguna distancia
rep=rep(2:length(rep));
frac=100*rep./i;
subplot(3,2,6)
plot(val,frac,'k.');   % Representacion grafica de la relacion distancia - porcentaje de ocurrencia de dicha distancia
xlabel('Posicion en la pila LRU');
ylabel('Porcentaje de ocurrencia de dicha distancia');
title('Localidad temporal');
hold on;
