% A esta funcion se le pasa como parametros una tabla con donde los
% identificadores son el primer campo y el tamao es el segundo campo,
% estos identificadores son unicos. k es un parametro a partir del cual
% empieza la cola pesada.


function dist_tam3(sol,numrepid,k)

tamano_dist=sol(:,2);   % Nos quedamos con la columna de todos los tamaos

% Para hallar la correlacion nos quedamos con 50 intervalos de los que
% hallamos su frecuencia de acceso y representamos


sol_corr=[sol numrepid];
sol_corr=sortrows(sol_corr,2);
ejex=round(linspace(1,length(sol_corr),50))';
ejey=zeros(length(ejex),1);
for i=2:length(ejex)
    ejey(i)=sum(sol_corr(ejex(i-1):ejex(i),size(sol_corr,2)));
end
 % Representamos la relacion entre el tamao de los archivos y su
 % frecuencia (popularidad)
subplot(3,2,2);
bar(ejex,ejey,1,'k');        
xlabel('Tamao de los archivos');
ylabel('Frecuencia');
title('Correlacion tamao - frecuencia de acceso');


tamano_dist=sortrows(tamano_dist); % ordenamos los tamaos distintos
[numtam,numtamrep]=mmrepeat(tamano_dist);
pos=find(numtam==k); % Posicion donde pasamos de Lognormal a Pareto

% Hallamos el porcentaje de cada tamao
numtam=numtam(2:1:length(numtam));    % Quitamos el cero
numtamrep=numtamrep(2:1:length(numtamrep));
porcentam=numtamrep*100./sum(numtamrep);                        
% En teoria debo sacar analiticamente los valores de mu y sigma 
% lo haria del siguiente modo

[param]=lognfit(numtam(1:pos));
acum=cumsum(porcentam(1:pos));
simlogn=logncdf(numtam(1:pos),param(1),param(2));    
subplot(3,2,3)
semilogx(numtam(1:pos),acum,'k-',numtam(1:pos),100*simlogn,'k--');
xlabel('Tamao de los archivos en log10(Bytes)');
ylabel('Porcentaje');
title('CDF del tamao del Cuerpo (Distribucion lognormal)');
hold on;
legend1 = legend({'real','ideal'});
legend boxoff;
[mureal,sigmareal]=lognstat(param(1),param(2));
annotation3 = annotation('textbox','Position',[0.23 0.55 0.04 0.01],...
         'String',{'mu real=',mureal,'sigma real=',sqrt(sigmareal)},...
         'FontSize',8,'LineStyle','none');
     
subplot(3,2,4)
%pdfy=lognpdf(numtam(1:pos),param(1),param(2));   
semilogx(numtam,porcentam,'k-');%,numtam(1:pos),100*pdfy,'k.-');    
xlabel('Tamao de los archivos en log10(Bytes)');
ylabel('Porcentaje');
title('PDF del tamao');
hold on;

acum=cumsum(porcentam);
subplot(3,2,5)
fneg=(1-acum/100);
loglog(numtam,fneg,'k.');
xlabel('Tamao de los archivos en log10(Bytes)');
ylabel('log10(P[X > x])');
title('CDF del tamao de la Cola (Distribucion de Pareto)');
hold on;
annotation2 = annotation('textbox','Position',[0.23 0.23 0.04 0.01],...
         'String',{'k=',k},'FontSize',8,'LineStyle','none');

% A ojo comprobamos que la pendiente lineal comienza a partir de la
% muestra 9000 (poco antes del 4 en el eje logaritmico x) por lo que
% podemos hallar la media d la pendiente  d(log10(fneg(x))/d(log x)= - alfa
% Este valor es un parametro para averiguar la pendiente de la cola
% a partir de este valor 

% disp('El porcentaje de archivos en cola es ');
% disp(100*sum(numtamrep(pos+1:end))/sum(numtamrep));
% disp('El valor de la pendiente de la cola pesada es ');
% disp(median(diff(log10(fneg(pos:length(fneg))))./diff(log10(numtam(pos:length(numtam))))));
