% A esta funcion se le pasa como parametros una tabla con donde los
% identificadores son el primer campo y el tamao es el segundo campo,
% estos identificadores son unicos. k es un parametro a partir del cual
% empieza la cola pesada.


function dist_tam3plus(sol,numrepid,k,m)
% m es el indice de la cola de pareto, es un parametro que pasa el usuario

tamano_dist=sol(:,2);   % Nos quedamos con la columna de todos los tamaos

% Para hallar la correlacion nos quedamos con 50 intervalos de los que
% hallamos su frecuencia de acceso y representamos


sol_corr=[sol numrepid];
sol_corr=sortrows(sol_corr,2);
ejex=round(linspace(1,length(sol_corr),50))';
ejey=zeros(length(ejex),1);
for i=2:length(ejex)
    ejey(i)=sum(sol_corr(ejex(i-1):ejex(i),size(sol_corr,2)));
end
 % Representamos la relacion entre el tamao de los archivos y su
 % frecuencia (popularidad)
subplot(3,2,2);
bar(sol_corr(ejex(1:47),2),ejey(1:47),0.8,'k');        
xlabel('Tamao de los archivos');
ylabel('Frecuencia');
title('Correlacion tamao - frecuencia de acceso');
corr=round(mean(ejey)/mean(ejey(1:15)));
if corr==1
    correlacion=0;
elseif corr>1
    correlacion=1;
else
    correlacion=-1;
end
% Ahora deberiamos pintarlo en pantalla pero se desajusta en los distintos
% casos de correlacion positiva, negativa o nula
% hold on;
% text(100000,100000,'Correlacion = ','FontSize',8);
% text(175000,100000,num2str(correlacion),'FontSize',8);


tamano_dist=sortrows(tamano_dist); % ordenamos los tamaos distintos
[numtam,numtamrep]=mmrepeat(tamano_dist);
pos=find(numtam>=k,1); % Posicion donde pasamos de Lognormal a Pareto

% Hallamos el porcentaje de cada tamao
numtam=numtam(2:1:length(numtam));    % Quitamos el cero
numtamrep=numtamrep(2:1:length(numtamrep));
porcentam=numtamrep*100./sum(numtamrep);                        
% En teoria debo sacar analiticamente los valores de mu y sigma 
% lo haria del siguiente modo

[param]=lognfit(numtam(1:pos));
acum=cumsum(porcentam(1:pos));
simlogn=logncdf(numtam(1:pos),param(1),param(2));    
subplot(3,2,3)
semilogx(numtam(1:pos),acum,'k-',numtam(1:pos),100*simlogn,'k--','LineWidth',2);
xlabel('Tamao de los archivos en log10(Bytes)');
ylabel('Porcentaje');
title('CDF del tamao del Cuerpo (Distribucion lognormal)');
hold on;
legend1 = legend({'real','ideal'});
legend boxoff;
[mureal,sigmareal]=lognstat(param(1),param(2));
text(250,40,'Mu real = ','FontSize',8);
text(1000,40,num2str(mureal),'FontSize',8);
text(250,30,'Sigma real = ','FontSize',8);
text(1000,30,num2str(sqrt(sigmareal)),'FontSize',8);

% annotation3 = annotation('textbox','Position',[0.23 0.55 0.04 0.01],...
%          'String',{'mu real=',mureal,'sigma real=',sqrt(sigmareal)},...
%          'FontSize',8,'LineStyle','none');
%      
subplot(3,2,4)
%pdfy=lognpdf(numtam(1:pos),param(1),param(2));   
semilogx(numtam,porcentam,'k-');%,numtam(1:pos),100*pdfy,'k.-');    
xlabel('Tamao de los archivos en log10(Bytes)');
ylabel('Porcentaje');
title('PDF del tamao');
hold on;

acum=cumsum(porcentam);
subplot(3,2,5)
fneg=(1-acum/100);
plot(log10(numtam),log10(fneg),'k.');
xlabel('Tamao de los archivos en log10(Bytes)');
ylabel('log10(P[X > x])');
title('CDF del tamao de la Cola (Distribucion de Pareto)');
hold on;
text(4,-5,'k = ','FontSize',8);
text(4.3,-5,num2str(k),'FontSize',8);
% annotation2 = annotation('textbox','Position',[0.23 0.23 0.04 0.01],...
%          'String',{'k=',k},'FontSize',8,'LineStyle','none');
mitad=((log10(numtam(end))-log10(k))/2)+log10(k);
pos2=find(log10(numtam)>mitad,1);
y=-m*(log10(numtam)-log10(numtam(pos2)))+log10(fneg(pos2));
plot(log10(numtam),y,'k--');
legend3 = legend({'real','ideal'});
legend boxoff;
% A ojo comprobamos que la pendiente lineal comienza a partir de la
% muestra 9000 (poco antes del 4 en el eje logaritmico x) por lo que
% podemos hallar la media d la pendiente  d(log10(fneg(x))/d(log x)= - alfa
% Este valor es un parametro para averiguar la pendiente de la cola
% a partir de este valor 

disp('El porcentaje de archivos en cola es ');
porc_cola=100*sum(numtamrep(pos+1:end))/sum(numtamrep);
disp(porc_cola);
disp('El valor de la pendiente de la cola pesada es ');
x0=k;
y0=log10(fneg(find(numtam>x0,1)));
x1=10^(floor(log10((numtam(end))))-2);
y1=log10(fneg(find(numtam>x1,1)));
pendte=((y1-y0)/(log10(x1)-log10(x0)));
disp(pendte);
text(4,-7,'beta = ','FontSize',8);
text(4.6,-7,num2str(-pendte),'FontSize',8);

% Guardamos todos los variables relevantes en el archivo parametros.txt
 fid = fopen('parametros.txt','at');
 fprintf(fid,'%g\n',-pendte);
 fprintf(fid,'%g\n',porc_cola);
 fprintf(fid,'%g\n',mureal);
 fprintf(fid,'%g\n',sqrt(sigmareal));
 fprintf(fid,'%g\n',correlacion);
 fclose(fid);